package com.hikcreate.update_hbase.controller;

import com.hikcreate.update_hbase.service.DmsmpService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * 放管服的预警点
 */
@RestController
@RequestMapping("/dmsmp")
public class DmsmpController {

    @Autowired
    private DmsmpService dmsmpService;


    /**
     * 临时号牌：同一机动车车辆四次临牌办理
     * @param times 次数
     */
    @GetMapping("/tempplate")
    public void tempplateWarn(@RequestParam("times") Integer times){
        dmsmpService.tempplateWarn(times);
    }

    /**
     * 所有人和车牌都改变预警
     */
    @GetMapping("/plateAndSyrChange")
    public void plateAndSyrChange(){
        dmsmpService.plateAndSyrChange(0);
    }

    /**
     * 共同所有人
     */
    @GetMapping("/commonSyr")
    public void commonSyr(){
        dmsmpService.commonSyr(0);
    }

    /**
     * 姓名和身份证号码同时改变
     */
    @GetMapping("/drvNameAndCard")
    public void drvNameAndCard(){
        dmsmpService.drvNameAndCard(0);
    }

    /**
     * 制证后推办
     */
    @GetMapping("/certicateQuit")
    public void certicateQuit(){
        dmsmpService.certicateQuit(0);
    }

    /**
     * 同一所有人多次变更号牌
     */
    @GetMapping("/hisSyrPlateChangeMany")
    public void hisSyrPlateChangeMany(){
        dmsmpService.syrPlateChangeMany(0);
    }


    /**
     *车辆短期解押
     */
    @GetMapping("/getHisMortgageCancel")
    public void getHisMortgageCancel(){
        dmsmpService.getHisMortgageCancel(0);
    }

    /**
     *退办业务短期办结
     */
    @GetMapping("/getHisRetireDealAgain")
    public void getHisRetireDealAgain(){
        dmsmpService.getHisRetireDealAgain(0);
    }

    /**
     * 同步残疾人车辆：规则---审批通过，符合条件，核发通过
     */
    @GetMapping("/synDeformedproposer")
    public void synDeformedproposer(){
        dmsmpService.synDeformedproposer(0);
    }

}
