package com.hikcreate.update_hbase.schedule;

import com.hikcreate.update_hbase.service.UpdateEsAcdService;
import com.hikcreate.update_hbase.service.VehFlowService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

@Component
public class UpdateEs {
    @Autowired
    private UpdateEsAcdService updateEsAcdService;
    @Autowired
    private VehFlowService vehFlowService;
    @Value("${es.acd.day.int}")
    private int pastDayAcd;
    @Value("${es.vehflow.day.int}")
    private int pastDayVehflow;

    @Scheduled(cron = "0 10 8 * * ?")
    public void AcdEs10Day() {
        updateEsAcdService.AcdEsDay(pastDayAcd);
    }

    @Scheduled(cron = "0 5/20 * * * ?")
    public void AcdEs20Min(){
        updateEsAcdService.AcdEs20Min();
    }

    @Scheduled(cron = "0 15 8 * * ?")
    public void AcdHuman10day(){
        updateEsAcdService.AcdHumanDay(pastDayAcd);
    }




}
